

import NetworkerThread from '../networker';

import Request from './request';
import { NetMessage } from '../networker/net-message';

class MapEmitter extends Map {
  constructor(emitter, scope) {
    super();
    this.scope = scope;
    Object.defineProperty(this, 'emitter', {
      enumerable: false,
      configurable: true,
      writable: false,
      value: emitter
    });
  }
  set(key, value) {
    this.emitter.emit(this.scope, { key, value });
    return super.set(key, value);
  }
  delete(key) {
    this.emitter.emit(this.scope, key);
    return super.delete(key);
  }
  //$FlowIssue
  [Symbol.species](prop) {
    return new Map(prop);
  }
}

class State {
  constructor() {
    this.threads = new Map();
    this.requests = new Map();
    this.messages = new Map();
  }

}

export default State;
//# sourceMappingURL=state.js.map