'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _hold = require('@most/hold');

var _most = require('most');

var _eventemitter = require('eventemitter2');

var _eventemitter2 = _interopRequireDefault(_eventemitter);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Property = (name, value, emitter) => {
  var plainStream = (0, _most.fromEvent)(name, emitter);
  var property = (0, _hold.hold)(plainStream);
  return {
    get: property,
    set(value) {
      emitter.emit(name, value);
    }
  };
};

exports.default = Property;
//# sourceMappingURL=property.js.map